"""change QA terminology

Revision ID: 68a8ad53ad74
Revises: 7018d6a27433
Create Date: 2023-04-03 14:25:39.373189

"""
from alembic import op


# revision identifiers, used by Alembic.
revision = "68a8ad53ad74"
down_revision = "0dc708eecbc6"
branch_labels = None
depends_on = None


def upgrade():
    op.execute(
        """
        ALTER TABLE capability_requests
        RENAME COLUMN assigned_da to stage_1_reviewer;
        """
    )
    op.execute(
        """
        ALTER TABLE capability_requests
        RENAME COLUMN assigned_aod to stage_2_reviewer;
        """
    )
    op.execute(
        """
        ALTER TABLE capability_versions
        RENAME COLUMN da_notes to internal_notes;
        """
    )
    op.execute(
        """
        UPDATE qa_staff
        SET "group" = 'Stage 1'
        WHERE "group" = 'DA';
        """
    )

    # Remove duplicate entries
    op.execute(
        """
        CREATE TABLE qa_staff_tmp (LIKE qa_staff);
        """
    )
    op.execute(
        """
        INSERT INTO qa_staff_tmp(user_name, "group", available, email)
        SELECT
            DISTINCT ON (user_name, "group") user_name, "group", available, email
        FROM qa_staff;
        """
    )
    op.execute(
        """
        DROP TABLE qa_staff;
        """
    )
    op.execute(
        """
        ALTER TABLE qa_staff_tmp
        RENAME TO qa_staff;
        """
    )
    # Put back unique constraint
    op.execute(
        """
        ALTER TABLE qa_staff
        ADD PRIMARY KEY (user_name,"group");
        """
    )
    op.execute(
        """
        UPDATE qa_staff
        SET "group" = 'Stage 2'
        WHERE "group" = 'AOD';
        """
    )
    op.execute(
        """
        UPDATE capability_executions
        SET state='Stage 2 Review'
        WHERE state='AoD Review';
        """
    )


def downgrade():
    op.execute(
        """
        ALTER TABLE capability_requests
        RENAME COLUMN stage_1_reviewer to assigned_da;
        """
    )
    op.execute(
        """
        ALTER TABLE capability_requests
        RENAME COLUMN stage_2_reviewer to assigned_aod;
        """
    )
    op.execute(
        """
        ALTER TABLE capability_versions
        RENAME COLUMN internal_notes to da_notes;
        """
    )
    op.execute(
        """
        UPDATE qa_staff
        SET "group" = 'DA'
        WHERE "group" = 'Stage 1';
        """
    )
    op.execute(
        """
        UPDATE qa_staff
        SET "group" = 'AOD'
        WHERE "group" = 'Stage 2';
        """
    )
    op.execute(
        """
        ALTER TABLE qa_staff
        DROP CONSTRAINT qa_staff_pkey;
        """
    )
    op.execute(
        """
        UPDATE capability_executions
        SET state='AoD Review'
        WHERE state='Stage 2 Review';
        """
    )
